﻿<%@ Page Title="Home Page" Language="C#" MasterPageFile="~/Site.master" AutoEventWireup="true"
    CodeBehind="Default.aspx.cs" Inherits="jQuery._Default" %>

<asp:Content ID="HeaderContent" runat="server" ContentPlaceHolderID="HeadContent">
</asp:Content>
<asp:Content ID="BodyContent" runat="server" ContentPlaceHolderID="MainContent">
    <table id="gridTarget">
    </table>
    <br />
    <input type="radio" value="0" name="col" checked="checked" />First Column
    <input type="radio" value="1" name="col" />Second Column
    <input type="radio" value="2" name="col" />Third Column
    <br />
    <input type="text" id="size" />px
    <input type="button" id="upd" value="Update" />
    <br /> <br />
    <div id="slide"></div> 
    <br />
    <label>Percent of grid witdh: <a id="slider_val"></a></label>

    <script type="text/javascript">
        $(document).ready(function () {
            // NetFlix's web service for movie information
            var data_url = "http://odata.netflix.com/Catalog/Titles?$format=json&$callback=?";
            var jsonp = new $.ig.JSONPDataSource({ dataSource: data_url, responseDataKey: "d.results" });
            var selectedColumn = 0;

            // saving the various page elements into variables
            var slider_val = $("#slider_val");
            var gridTarget = $("#gridTarget");
            var slider = $("#slide");
            var widthInput = $("#size");

            // igGrid initialization - pay attention to the features declaration
            gridTarget.igGrid({
                autoGenerateColumns: false,
                width: "600px",
                columns: [
                    { headerText: "Movie Name", key: "Name" },
                    { headerText: "Release Year", key: "ReleaseYear" },
                    { headerText: "Rating", key: "AverageRating" }
                ],
                features: [
                    { name: "Paging", pageSize: 5 },
                    { name: "Resizing", deferredResizing: true, columnSettings: [ // this line enables column resizing
                        {columnIndex: 0, minimumWidth: 20 },
                        { columnIndex: 1, minimumWidth: 20 },
                        { columnIndex: 2, minimumWidth: 20 }
                    ]
                    }
                ],
                dataSource: jsonp
            });

            // function used to get the grid's width and convert it to a regular number if it's in the "###px" format
            function determineGridWidth() {
                var grid_width = gridTarget.igGrid("option", "width");
                if (typeof grid_width == "string") {
                    return grid_width.substring(0, grid_width.length - 2) * 1;
                }
                else { return grid_width; }
            }

            // igNumberEditor initialization , here we use the grid width function from above
            widthInput.igNumericEditor({
                dataMode: "int",
                minValue: 10,
                maxValue: determineGridWidth(),
                button: "spin",
                value: 10
            });

            // jQuery slider initialization , again we use the grid width function
            slider.slider({
                min: 10,
                max: determineGridWidth(),
                value: 10
            }).css("width", determineGridWidth()); // slider is as wide as the grid is.

            // function used to update the display under the slider
            function updSliderText() {
                slider_val.text((slider.slider("value") * 1 / determineGridWidth()) * 100);
            }

            // resizes the column of the clicked cell to the length of the longest entry in the column
            gridTarget.bind("iggridcellclick", function (evt, ui) {
                var col = ui.colIndex;
                $(this).igGridResizing("resize", col);
            });

            // this bind changes the column which we want to resize
            $("input[name='col']").click(function () {
                selectedColumn = $(this).attr("value") * 1;
            });

            // this bind is about the "Update" button - the currently selected column gets resized to the value
            // of the igNumericEditor
            $("#upd").click(function () {
                gridTarget.igGridResizing("resize", selectedColumn, widthInput.igNumericEditor("value"));
                slider.slider("value", widthInput.igNumericEditor("value"));
                updSliderText();
            });

            // this bind handles the slide event of the slider and resizes the currently selected column
            slider.bind("slide", function (event, ui) {
                updSliderText();
                widthInput.igNumericEditor("value", ui.value);
                gridTarget.igGridResizing("resize", selectedColumn, ui.value);
            });

            gridTarget.bind("iggridresizingcolumnresized", function (evt, ui) {
                alert("Column with key: " + ui.columnKey + " was resized to: " + ui.newWidth + "px.");
            });

            // initial update of the display label under the slider
            updSliderText();
        });
    </script>
</asp:Content>
